#include <iostream>
#include <math.h>
using namespace std;

int main()
{
    long long N,M;
    cin >> N >> M;
    long long B[M];
    for(int i = 1 ; i <= M; i++)
        cin >> B[i];

    long long A[N+1];
    for(int i = 1; i <= N; i++){
        A[i] = i;
    }

    for(int i = 0; i <= N-M; i++){
        for (int j=1; j<=M; j++)
            A[i + B[j]] = A[i + j];
    }
    long long X = 0;
    long long C;
    cin >> C;
    for(int i = 1; i <= N; i++){
        X += pow(C, i)*A[i];
    }
    X = X % 998244353;

    cout << X;
    return 0;
}